﻿using Steema.TeeChart;
using Steema.TeeChart.Drawing;
using Steema.TeeChart.Styles;
using Steema.TeeChart.Tools;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
  public partial class SurfaceTest_Form : Form
  {

    public SurfaceTest_Form()
    {
      InitializeComponent();

      tChart1 = new TChart();
      tChart1.Dock = DockStyle.Fill;
      this.splitContainer1.Panel2.Controls.Add(tChart1);
      InitializeChart();
    }



    TChart tChart1;
    private void InitializeChart()
    {
      string x = "XValues";
      string y = "YValues";
      string z = "ZValues";

      for (int i = 0; i < 50; i++)
      {
        AddSuface(CreateDataTable(x, y, z), x, y, z);
      }

      tChart1.Aspect.Orthogonal = false;
      tChart1.Aspect.Chart3DPercent = 75;
      tChart1.Aspect.Zoom = 80;

    }

    private DataTable CreateDataTable(string xColName, string yColName, string zColName)
    {
      DataTable result = new DataTable();
      result.Columns.Add(new DataColumn(xColName, typeof(double)));
      result.Columns.Add(new DataColumn(yColName, typeof(double)));
      result.Columns.Add(new DataColumn(zColName, typeof(double)));

      double x, y, z;
      Random rnd = new Random();

      for (int i = 0; i < 35; i++)
      {
        x = i;
        for (int j = 0; j < 35; j++)
        {
          z = j;
          y = Math.Cos(i * 10) * Math.Sin(j * 10);
          DataRow row = result.NewRow();
          row[0] = x;
          row[1] = y;
          row[2] = z;
          result.Rows.Add(row);
        }
      }

      return result;
    }

    void AddSuface(DataTable dataSourceTable, string xColName, string yColName, string zColName)
    {
      Surface surface = new Surface();
      surface.IrregularGrid = true;
      //Add data to the surface object
      for (int Index = 0; Index < dataSourceTable.Rows.Count; Index++)
      {
        DataRow xrow = dataSourceTable.Rows[Index];
        double xVal = Convert.ToDouble(xrow[xColName]);
        for (int Index1 = 0; Index1 < dataSourceTable.Rows.Count; Index1++)
        {
          DataRow row = dataSourceTable.Rows[Index1];
          double zVal = Convert.ToDouble(row[zColName]);
          double yVal = Convert.ToDouble(row[yColName]);
          surface.Add(xVal, yVal, zVal);
        }
      }

      //surface.CheckDataSource();
      surface.UseColorRange = false;
      surface.UsePalette = true;
      surface.PaletteStyle = Steema.TeeChart.Styles.PaletteStyles.Rainbow;
      surface.PaletteSteps = 10;
    }


    private void InitializeComponent()
    {
      this.splitContainer1 = new System.Windows.Forms.SplitContainer();
      this.button2 = new System.Windows.Forms.Button();
      this.button1 = new System.Windows.Forms.Button();
      ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).BeginInit();
      this.splitContainer1.Panel1.SuspendLayout();
      this.splitContainer1.SuspendLayout();
      this.SuspendLayout();
      // 
      // splitContainer1
      // 
      this.splitContainer1.Dock = System.Windows.Forms.DockStyle.Fill;
      this.splitContainer1.Location = new System.Drawing.Point(0, 0);
      this.splitContainer1.Name = "splitContainer1";
      // 
      // splitContainer1.Panel1
      // 
      this.splitContainer1.Panel1.Controls.Add(this.button2);
      this.splitContainer1.Panel1.Controls.Add(this.button1);
      this.splitContainer1.Size = new System.Drawing.Size(887, 475);
      this.splitContainer1.SplitterDistance = 295;
      this.splitContainer1.TabIndex = 0;
      // 
      // button2
      // 
      this.button2.Location = new System.Drawing.Point(12, 53);
      this.button2.Name = "button2";
      this.button2.Size = new System.Drawing.Size(75, 23);
      this.button2.TabIndex = 1;
      this.button2.Text = "button2";
      this.button2.UseVisualStyleBackColor = true;
      // 
      // button1
      // 
      this.button1.Location = new System.Drawing.Point(12, 24);
      this.button1.Name = "button1";
      this.button1.Size = new System.Drawing.Size(75, 23);
      this.button1.TabIndex = 0;
      this.button1.Text = "button1";
      this.button1.UseVisualStyleBackColor = true;
      this.button1.Click += new System.EventHandler(this.button1_Click);
      // 
      // Form1
      // 
      this.ClientSize = new System.Drawing.Size(887, 475);
      this.Controls.Add(this.splitContainer1);
      this.Name = "Form1";
      this.splitContainer1.Panel1.ResumeLayout(false);
      ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).EndInit();
      this.splitContainer1.ResumeLayout(false);
      this.ResumeLayout(false);

    }

    private void button1_Click(object sender, EventArgs e)
    {
      tChart1.ShowEditor();
    }



  }
}
